您的位置:首页 > 其它

hdu 4472 Count (递推)

2015-12-19 11:58 375 查看


Count

Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)

Total Submission(s): 1756 Accepted Submission(s): 1133



Problem Description

Prof. Tigris is the head of an archaeological team who is currently in charge of an excavation in a site of ancient relics.

This site contains relics of a village where civilization once flourished. One night, examining a writing record, you find some text meaningful to you. It reads as follows.

“Our village is of glory and harmony. Our relationships are constructed in such a way that everyone except the village headman has exactly one direct boss and nobody will be the boss of himself, the boss of boss of himself, etc. Everyone expect the headman
is considered as his boss’s subordinate. We call it relationship configuration. The village headman is at level 0, his subordinates are at level 1, and his subordinates’ subordinates are at level 2, etc. Our relationship configuration is harmonious because
all people at same level have the same number of subordinates. Therefore our relationship is …”

The record ends here. Prof. Tigris now wonder how many different harmonious relationship configurations can exist. He only cares about the holistic shape of configuration, so two configurations are considered identical if and only if there’s a bijection of
n people that transforms one configuration into another one.

Please see the illustrations below for explanation when n = 2 and n = 4.



The result might be very large, so you should take module operation with modules 109 +7 before print your answer.

Input

There are several test cases.

For each test case there is a single line containing only one integer n (1 ≤ n ≤ 1000).

Input is terminated by EOF.

Output

For each test case, output one line “Case X: Y” where X is the test case number (starting from 1) and Y is the desired answer.

Sample Input

1
2
3
40
50
600
700


Sample Output

Case 1: 1
Case 2: 1
Case 3: 2
Case 4: 924
Case 5: 1998
Case 6: 315478277
Case 7: 825219749


对于每一个合法图形。记最底层个数为j,则再添加一层添加的个数必须是j的倍数。能够用dp[i][j]表示i个点最底层为j个时的个数,对于数据范围内的N遍历得到答案。(属于“我为人人”型的递推关系)

dp[i][j]-->dp[i+j*k][j*k](k=1...N)

#include <iostream>
#include<stdio.h>
#include<string.h>
#include<math.h>
#include<algorithm>
using namespace std;
#define N 1010
#define LL __int64
const int mod=1000000007;
int f

,ans
;
void inti()
{
int i,j,k;
memset(f,0,sizeof(f));
f[1][1]=1;
for(i=1;i<=1000;i++)
{
for(j=1;j<=1000;j++)
{
if(f[i][j]==0)     //由当前合法状态推得其它状态
continue;
for(k=1;k<=1000;k++)
{
int t1=j*k;
int t2=t1+i;
if(t2>1000)
break;
f[t2][t1]+=f[i][j];
if(f[t2][t1]>=mod)
f[t2][t1]%=mod;
}
}
}
for(i=1;i<=1000;i++)
{
int tmp=0;
for(j=1;j<=i;j++)
tmp=(tmp+f[i][j])%mod;
ans[i]=tmp;
}
}
int main()
{
int n,cnt=1;
inti();
while(scanf("%d",&n)!=-1)
{
printf("Case %d: %d\n",cnt++,ans
);
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: